---
title: Libraries and implementations
description: Code, libraries and SDKs for the Mastodon API in a range of programming languages.
menu:
  docs:
    weight: 60
    parent: client
---

Thank you to our awesome developer community, for supporting the project with a wide range of implementations of the API. If you have built a library or SDK for the Mastodon API, [let us know](https://github.com/mastodon/mastodon/discussions) about it, and it may be included below in a future update.

Remember to check how recently the library was updated, and whether it includes the API features you may want to use.

## Arduino / ESP32 / IoT {#arduino-iot}

* [lyuba](https://github.com/ringtailsoftware/lyuba)
## C# (.NET Standard) {#c-net-standard}

* [MastodonAPI](https://github.com/golf1052/MastodonAPI)
* [Mastodot](https://github.com/yamachu/Mastodot)
* [Mastonet](https://github.com/glacasa/Mastonet)
* [TootNet](https://github.com/cucmberium/TootNet)
* [mastodon-api-cs](https://github.com/pawotter/mastodon-api-cs)
* [Mastodon.Net](https://github.com/Tlaster/Mastodon.Net)

## C++ {#c}

* [mastodonpp](https://schlomp.space/tastytea/mastodonpp)

## Common Lisp {#common-lisp}

* [mastodon-cl](https://github.com/compufox/mastodon-cl)
* [tooter](https://github.com/Shinmera/tooter)

## Crystal {#crystal}

* [mastodon-api-crystal](https://github.com/renatolond/mastodon-api-crystal)

## Dart

* [mastodon-api](https://github.com/mastodon-dart/mastodon-api)
* [mastodon-oauth](https://github.com/mastodon-dart/mastodon-oauth2)
* [mastodon](https://github.com/mykdavies/Mastodon)
* [dartodon](https://github.com/darkcl/dartodon)

## Elixir {#elixir}

* [hunter](https://github.com/milmazz/hunter)

## Erlang {#erlang}

* [masterldon](https://github.com/igb/masterldon)

## Go {#go}

* [go-mastodon](https://github.com/mattn/go-mastodon)
* [madon](https://github.com/McKael/madon)
* [go-mastodon-api](https://github.com/aaronland/go-mastodon-api)

## Haskell {#haskell}

* [hastodon](https://github.com/syucream/hastodon)

## Java {#java}

* [BigBone](https://github.com/andregasser/bigbone)
* [Mastodon4J](https://github.com/Mastodon4J/Mastodon4J)
* [mastodon-jfx](https://github.com/wakingrufus/mastodon-jfx)

## JavaScript {#javascript}

* [megalodon](https://github.com/h3poteto/megalodon)
* [masto.js](https://github.com/neet/masto.js)
* [libodonjs](https://github.com/Zatnosk/libodonjs)

## JavaScript (Browser) {#javascript-browser}

* [mastodon.js](https://github.com/Kirschn/mastodon.js)

## JavaScript (Node.js) {#javascript-node-js}

* [mastodon-api](https://github.com/vanita5/mastodon-api)

## Kotlin {#kotlin}

* [BigBone](https://github.com/andregasser/bigbone)
* [mastodonk](https://github.com/outadoc/mastodonk)

## Nim {#nim}

* [Mastonim](https://github.com/matrix07012/Mastonim)

## Objective-C {#objective-c}

* [Cocotodon](https://github.com/shibafu528/Cocotodon)

## Perl {#perl}

* [Mastodon::Client](https://metacpan.org/pod/Mastodon::Client)

## PHP {#php}

* [Phediverse Mastodon REST Client](https://github.com/phediverse/mastodon-rest)
* [TootoPHP](https://framagit.org/MaxKoder/TootoPHP)
* [oauth2-mastodon](https://github.com/lrf141/oauth2-mastodon)
* [MastodonBotPHP](https://github.com/Eleirbag89/MastodonBotPHP)
* [mastodon-api-php-oauth](https://github.com/yks118/Mastodon-api-php-oauth)
* [mastodon-api-php](https://github.com/colorfield/mastodon-api-php)
* [Mastodon API for Laravel](https://github.com/kawax/laravel-mastodon-api)
* [Mastodon for Drupal](https://github.com/colorfield/mastodon)
* [Mastodon for Socialite](https://github.com/kawax/socialite-mastodon)

## PowerShell {#powershell}

* [Mastodon](https://github.com/JB405/Mastodon)

## Python {#python}

* [Mastodon.py](https://github.com/halcy/Mastodon.py)
* [mastopy](https://gitlab.com/spla/mastopy)

## R {#r}

* [mastodon](https://github.com/ThomasChln/mastodon)
* [rtoot](https://github.com/schochastics/rtoot)

## Ruby {#ruby}

* [mastodon-api](https://github.com/mastodon/mastodon-api)

## Rust {#rust}

* [megalodon-rs](https://github.com/h3poteto/megalodon-rs)
* [mastodon-async](https://github.com/dscottboggs/mastodon-async)

## Scala {#scala}

* [scaladon](https://github.com/schwitzerm/scaladon)

## Scheme {#scheme}

### Guile {#guile}

* [Guile-Mastodon](https://codeberg.org/WammKD/Guile-Mastodon)

## Swift {#swift}

* [Mastodon.swift](https://github.com/Swiftodon/Mastodon.swift)
* [MastodonKit](https://github.com/MastodonKit/MastodonKit)
* [tootsdk](https://github.com/tootsdk/tootsdk)
* [MastodonAPI](https://github.com/li-bei/MastodonAPI)

## TypeScript {#typescript}

* [tsl-mastodon](https://github.com/typescriptlibs/tsl-mastodon-api)


